extern (C) :

alias uint   GLenum;
alias ubyte  GLboolean;
alias uint   GLbitfield;
alias byte   GLbyte;
alias short  GLshort;
alias int    GLint;
alias int    GLsizei;
alias ubyte  GLubyte;
alias ushort GLushort;
alias uint   GLuint;
alias float  GLfloat;
alias float  GLclampf;
alias double GLdouble;
alias double GLclampd;
alias void   GLvoid;
alias ubyte  uchar;

extern (C) struct GLUnurbs { }
extern (C) struct GLUquadric { }
extern (C) struct GLUtesselator { }
alias GLUnurbs      GLUnurbsObj;
alias GLUquadric    GLUquadricObj;
alias GLUtesselator GLUtesselatorObj;
alias GLUtesselator GLUtriangulatorObj;

void    D_glClearIndex( GLfloat c ) ;
void    D_glClearColor( GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha ) ;
void    D_glClear( GLbitfield mask ) ;
void    D_glIndexMask( GLuint mask ) ;
void    D_glColorMask( GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha ) ;
void    D_glAlphaFunc( GLenum func, GLclampf ref ) ;
void    D_glBlendFunc( GLenum sfactor, GLenum dfactor ) ;
void    D_glLogicOp( GLenum opcode ) ;
void    D_glCullFace( GLenum mode ) ;
void    D_glFrontFace( GLenum mode ) ;
void    D_glPointSize( GLfloat size ) ;
void    D_glLineWidth( GLfloat width ) ;
void    D_glLineStipple( GLint factor, GLushort pattern ) ;
void    D_glPolygonMode( GLenum face, GLenum mode ) ;
void    D_glPolygonOffset( GLfloat factor, GLfloat units ) ;
void    D_glPolygonStipple( GLubyte *mask ) ;
void    D_glGetPolygonStipple( GLubyte *mask ) ;
void    D_glEdgeFlag( GLboolean flag ) ;
void    D_glEdgeFlagv( GLboolean *flag ) ;
void    D_glScissor( GLint x, GLint y, GLsizei width, GLsizei height) ;
void    D_glClipPlane( GLenum plane, GLdouble *equation ) ;
void    D_glGetClipPlane( GLenum plane, GLdouble *equation ) ;
void    D_glDrawBuffer( GLenum mode ) ;
void    D_glReadBuffer( GLenum mode ) ;
void    D_glEnable( GLenum cap ) ;
void    D_glDisable( GLenum cap ) ;
GLboolean  D_glIsEnabled( GLenum cap ) ;
void    D_glEnableClientState( GLenum cap ) ;
void    D_glDisableClientState( GLenum cap ) ;
void    D_glGetBooleanv( GLenum pname, GLboolean *params ) ;
void    D_glGetDoublev( GLenum pname, GLdouble *params ) ;
void    D_glGetFloatv( GLenum pname, GLfloat *params ) ;
void    D_glGetIntegerv( GLenum pname, GLint *params ) ;
void    D_glPushAttrib( GLbitfield mask ) ;
void    D_glPopAttrib() ;
void    D_glPushClientAttrib( GLbitfield mask ) ;
void    D_glPopClientAttrib() ;
GLint   D_glRenderMode( GLenum mode ) ;
GLenum  D_glGetError() ;
GLubyte*  D_glGetString( GLenum name ) ;
void    D_glFinish() ;
void    D_glFlush() ;
void    D_glHint( GLenum target, GLenum mode ) ;
void    D_glClearDepth( GLclampd depth ) ;
void    D_glDepthFunc( GLenum func ) ;
void    D_glDepthMask( GLboolean flag ) ;
void    D_glDepthRange( GLclampd near_val, GLclampd far_val ) ;
void    D_glClearAccum( GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha ) ;
void    D_glAccum( GLenum op, GLfloat value ) ;
void    D_glMatrixMode( GLenum mode ) ;
void    D_glOrtho( GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble near_val, GLdouble far_val ) ;
void    D_glFrustum( GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble near_val, GLdouble far_val ) ;
void    D_glViewport( GLint x, GLint y, GLsizei width, GLsizei height ) ;
void    D_glPushMatrix() ;
void    D_glPopMatrix() ;
void    D_glLoadIdentity() ;
void    D_glLoadMatrixd( GLdouble *m ) ;
void    D_glLoadMatrixf( GLfloat *m ) ;
void    D_glMultMatrixd( GLdouble *m ) ;
void    D_glMultMatrixf( GLfloat *m ) ;
void    D_glRotated( GLdouble angle, GLdouble x, GLdouble y, GLdouble z ) ;
void    D_glRotatef( GLfloat angle, GLfloat x, GLfloat y, GLfloat z ) ;
void    D_glScaled( GLdouble x, GLdouble y, GLdouble z ) ;
void    D_glScalef( GLfloat x, GLfloat y, GLfloat z ) ;
void    D_glTranslated( GLdouble x, GLdouble y, GLdouble z ) ;
void    D_glTranslatef( GLfloat x, GLfloat y, GLfloat z ) ;
GLboolean  D_glIsList( GLuint list ) ;
void    D_glDeleteLists( GLuint list, GLsizei range ) ;
GLuint  D_glGenLists( GLsizei range ) ;
void    D_glNewList( GLuint list, GLenum mode ) ;
void    D_glEndList() ;
void    D_glCallList( GLuint list ) ;
void    D_glCallLists( GLsizei n, GLenum type, GLvoid *lists ) ;
void    D_glListBase( GLuint base ) ;
void    D_glBegin( GLenum mode ) ;
void    D_glEnd() ;
void    D_glVertex2d( GLdouble x, GLdouble y ) ;
void    D_glVertex2f( GLfloat x, GLfloat y ) ;
void    D_glVertex2i( GLint x, GLint y ) ;
void    D_glVertex2s( GLshort x, GLshort y ) ;
void    D_glVertex3d( GLdouble x, GLdouble y, GLdouble z ) ;
void    D_glVertex3f( GLfloat x, GLfloat y, GLfloat z ) ;
void    D_glVertex3i( GLint x, GLint y, GLint z ) ;
void    D_glVertex3s( GLshort x, GLshort y, GLshort z ) ;
void    D_glVertex4d( GLdouble x, GLdouble y, GLdouble z, GLdouble w ) ;
void    D_glVertex4f( GLfloat x, GLfloat y, GLfloat z, GLfloat w ) ;
void    D_glVertex4i( GLint x, GLint y, GLint z, GLint w ) ;
void    D_glVertex4s( GLshort x, GLshort y, GLshort z, GLshort w ) ;
void    D_glVertex2dv( GLdouble *v ) ;
void    D_glVertex2fv( GLfloat *v ) ;
void    D_glVertex2iv( GLint *v ) ;
void    D_glVertex2sv( GLshort *v ) ;
void    D_glVertex3dv( GLdouble *v ) ;
void    D_glVertex3fv( GLfloat *v ) ;
void    D_glVertex3iv( GLint *v ) ;
void    D_glVertex3sv( GLshort *v ) ;
void    D_glVertex4dv( GLdouble *v ) ;
void    D_glVertex4fv( GLfloat *v ) ;
void    D_glVertex4iv( GLint *v ) ;
void    D_glVertex4sv( GLshort *v ) ;
void    D_glNormal3b( GLbyte nx, GLbyte ny, GLbyte nz ) ;
void    D_glNormal3d( GLdouble nx, GLdouble ny, GLdouble nz ) ;
void    D_glNormal3f( GLfloat nx, GLfloat ny, GLfloat nz ) ;
void    D_glNormal3i( GLint nx, GLint ny, GLint nz ) ;
void    D_glNormal3s( GLshort nx, GLshort ny, GLshort nz ) ;
void    D_glNormal3bv( GLbyte *v ) ;
void    D_glNormal3dv( GLdouble *v ) ;
void    D_glNormal3fv( GLfloat *v ) ;
void    D_glNormal3iv( GLint *v ) ;
void    D_glNormal3sv( GLshort *v ) ;
void    D_glIndexd( GLdouble c ) ;
void    D_glIndexf( GLfloat c ) ;
void    D_glIndexi( GLint c ) ;
void    D_glIndexs( GLshort c ) ;
void    D_glIndexub( GLubyte c ) ;
void    D_glIndexdv( GLdouble *c ) ;
void    D_glIndexfv( GLfloat *c ) ;
void    D_glIndexiv( GLint *c ) ;
void    D_glIndexsv( GLshort *c ) ;
void    D_glIndexubv( GLubyte *c ) ;
void    D_glColor3b( GLbyte red, GLbyte green, GLbyte blue ) ;
void    D_glColor3d( GLdouble red, GLdouble green, GLdouble blue ) ;
void    D_glColor3f( GLfloat red, GLfloat green, GLfloat blue ) ;
void    D_glColor3i( GLint red, GLint green, GLint blue ) ;
void    D_glColor3s( GLshort red, GLshort green, GLshort blue ) ;
void    D_glColor3ub( GLubyte red, GLubyte green, GLubyte blue ) ;
void    D_glColor3ui( GLuint red, GLuint green, GLuint blue ) ;
void    D_glColor3us( GLushort red, GLushort green, GLushort blue ) ;
void    D_glColor4b( GLbyte red, GLbyte green, GLbyte blue, GLbyte alpha ) ;
void    D_glColor4d( GLdouble red, GLdouble green, GLdouble blue, GLdouble alpha ) ;
void    D_glColor4f( GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha ) ;
void    D_glColor4i( GLint red, GLint green, GLint blue, GLint alpha ) ;
void    D_glColor4s( GLshort red, GLshort green, GLshort blue, GLshort alpha ) ;
void    D_glColor4ub( GLubyte red, GLubyte green, GLubyte blue, GLubyte alpha ) ;
void    D_glColor4ui( GLuint red, GLuint green, GLuint blue, GLuint alpha ) ;
void    D_glColor4us( GLushort red, GLushort green, GLushort blue, GLushort alpha ) ;
void    D_glColor3bv( GLbyte *v ) ;
void    D_glColor3dv( GLdouble *v ) ;
void    D_glColor3fv( GLfloat *v ) ;
void    D_glColor3iv( GLint *v ) ;
void    D_glColor3sv( GLshort *v ) ;
void    D_glColor3ubv( GLubyte *v ) ;
void    D_glColor3uiv( GLuint *v ) ;
void    D_glColor3usv( GLushort *v ) ;
void    D_glColor4bv( GLbyte *v ) ;
void    D_glColor4dv( GLdouble *v ) ;
void    D_glColor4fv( GLfloat *v ) ;
void    D_glColor4iv( GLint *v ) ;
void    D_glColor4sv( GLshort *v ) ;
void    D_glColor4ubv( GLubyte *v ) ;
void    D_glColor4uiv( GLuint *v ) ;
void    D_glColor4usv( GLushort *v ) ;
void    D_glTexCoord1d( GLdouble s ) ;
void    D_glTexCoord1f( GLfloat s ) ;
void    D_glTexCoord1i( GLint s ) ;
void    D_glTexCoord1s( GLshort s ) ;
void    D_glTexCoord2d( GLdouble s, GLdouble t ) ;
void    D_glTexCoord2f( GLfloat s, GLfloat t ) ;
void    D_glTexCoord2i( GLint s, GLint t ) ;
void    D_glTexCoord2s( GLshort s, GLshort t ) ;
void    D_glTexCoord3d( GLdouble s, GLdouble t, GLdouble r ) ;
void    D_glTexCoord3f( GLfloat s, GLfloat t, GLfloat r ) ;
void    D_glTexCoord3i( GLint s, GLint t, GLint r ) ;
void    D_glTexCoord3s( GLshort s, GLshort t, GLshort r ) ;
void    D_glTexCoord4d( GLdouble s, GLdouble t, GLdouble r, GLdouble q ) ;
void    D_glTexCoord4f( GLfloat s, GLfloat t, GLfloat r, GLfloat q ) ;
void    D_glTexCoord4i( GLint s, GLint t, GLint r, GLint q ) ;
void    D_glTexCoord4s( GLshort s, GLshort t, GLshort r, GLshort q ) ;
void    D_glTexCoord1dv( GLdouble *v ) ;
void    D_glTexCoord1fv( GLfloat *v ) ;
void    D_glTexCoord1iv( GLint *v ) ;
void    D_glTexCoord1sv( GLshort *v ) ;
void    D_glTexCoord2dv( GLdouble *v ) ;
void    D_glTexCoord2fv( GLfloat *v ) ;
void    D_glTexCoord2iv( GLint *v ) ;
void    D_glTexCoord2sv( GLshort *v ) ;
void    D_glTexCoord3dv( GLdouble *v ) ;
void    D_glTexCoord3fv( GLfloat *v ) ;
void    D_glTexCoord3iv( GLint *v ) ;
void    D_glTexCoord3sv( GLshort *v ) ;
void    D_glTexCoord4dv( GLdouble *v ) ;
void    D_glTexCoord4fv( GLfloat *v ) ;
void    D_glTexCoord4iv( GLint *v ) ;
void    D_glTexCoord4sv( GLshort *v ) ;
void    D_glRasterPos2d( GLdouble x, GLdouble y ) ;
void    D_glRasterPos2f( GLfloat x, GLfloat y ) ;
void    D_glRasterPos2i( GLint x, GLint y ) ;
void    D_glRasterPos2s( GLshort x, GLshort y ) ;
void    D_glRasterPos3d( GLdouble x, GLdouble y, GLdouble z ) ;
void    D_glRasterPos3f( GLfloat x, GLfloat y, GLfloat z ) ;
void    D_glRasterPos3i( GLint x, GLint y, GLint z ) ;
void    D_glRasterPos3s( GLshort x, GLshort y, GLshort z ) ;
void    D_glRasterPos4d( GLdouble x, GLdouble y, GLdouble z, GLdouble w ) ;
void    D_glRasterPos4f( GLfloat x, GLfloat y, GLfloat z, GLfloat w ) ;
void    D_glRasterPos4i( GLint x, GLint y, GLint z, GLint w ) ;
void    D_glRasterPos4s( GLshort x, GLshort y, GLshort z, GLshort w ) ;
void    D_glRasterPos2dv( GLdouble *v ) ;
void    D_glRasterPos2fv( GLfloat *v ) ;
void    D_glRasterPos2iv( GLint *v ) ;
void    D_glRasterPos2sv( GLshort *v ) ;
void    D_glRasterPos3dv( GLdouble *v ) ;
void    D_glRasterPos3fv( GLfloat *v ) ;
void    D_glRasterPos3iv( GLint *v ) ;
void    D_glRasterPos3sv( GLshort *v ) ;
void    D_glRasterPos4dv( GLdouble *v ) ;
void    D_glRasterPos4fv( GLfloat *v ) ;
void    D_glRasterPos4iv( GLint *v ) ;
void    D_glRasterPos4sv( GLshort *v ) ;
void    D_glRectd( GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2 ) ;
void    D_glRectf( GLfloat x1, GLfloat y1, GLfloat x2, GLfloat y2 ) ;
void    D_glRecti( GLint x1, GLint y1, GLint x2, GLint y2 ) ;
void    D_glRects( GLshort x1, GLshort y1, GLshort x2, GLshort y2 ) ;
void    D_glRectdv( GLdouble *v1, GLdouble *v2 ) ;
void    D_glRectfv( GLfloat *v1, GLfloat *v2 ) ;
void    D_glRectiv( GLint *v1, GLint *v2 ) ;
void    D_glRectsv( GLshort *v1, GLshort *v2 ) ;
void    D_glShadeModel( GLenum mode ) ;
void    D_glLightf( GLenum light, GLenum pname, GLfloat param ) ;
void    D_glLighti( GLenum light, GLenum pname, GLint param ) ;
void    D_glLightfv( GLenum light, GLenum pname, GLfloat *params ) ;
void    D_glLightiv( GLenum light, GLenum pname, GLint *params ) ;
void    D_glGetLightfv( GLenum light, GLenum pname, GLfloat *params ) ;
void    D_glGetLightiv( GLenum light, GLenum pname, GLint *params ) ;
void    D_glLightModelf( GLenum pname, GLfloat param ) ;
void    D_glLightModeli( GLenum pname, GLint param ) ;
void    D_glLightModelfv( GLenum pname, GLfloat *params ) ;
void    D_glLightModeliv( GLenum pname, GLint *params ) ;
void    D_glMaterialf( GLenum face, GLenum pname, GLfloat param ) ;
void    D_glMateriali( GLenum face, GLenum pname, GLint param ) ;
void    D_glMaterialfv( GLenum face, GLenum pname, GLfloat *params ) ;
void    D_glMaterialiv( GLenum face, GLenum pname, GLint *params ) ;
void    D_glGetMaterialfv( GLenum face, GLenum pname, GLfloat *params ) ;
void    D_glGetMaterialiv( GLenum face, GLenum pname, GLint *params ) ;
void    D_glColorMaterial( GLenum face, GLenum mode ) ;
void    D_glPixelZoom( GLfloat xfactor, GLfloat yfactor ) ;
void    D_glPixelStoref( GLenum pname, GLfloat param ) ;
void    D_glPixelStorei( GLenum pname, GLint param ) ;
void    D_glPixelTransferf( GLenum pname, GLfloat param ) ;
void    D_glPixelTransferi( GLenum pname, GLint param ) ;
void    D_glPixelMapfv( GLenum map, GLint mapsize, GLfloat *values ) ;
void    D_glPixelMapuiv( GLenum map, GLint mapsize, GLuint *values ) ;
void    D_glPixelMapusv( GLenum map, GLint mapsize, GLushort *values ) ;
void    D_glGetPixelMapfv( GLenum map, GLfloat *values ) ;
void    D_glGetPixelMapuiv( GLenum map, GLuint *values ) ;
void    D_glGetPixelMapusv( GLenum map, GLushort *values ) ;
void    D_glBitmap( GLsizei width, GLsizei height, GLfloat xorig, GLfloat yorig, GLfloat xmove, GLfloat ymove, GLubyte *bitmap ) ;
void    D_glReadPixels( GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid *pixels ) ;
void    D_glDrawPixels( GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid *pixels ) ;
void    D_glCopyPixels( GLint x, GLint y, GLsizei width, GLsizei height, GLenum type ) ;
void    D_glStencilFunc( GLenum func, GLint ref, GLuint mask ) ;
void    D_glStencilMask( GLuint mask ) ;
void    D_glStencilOp( GLenum fail, GLenum zfail, GLenum zpass ) ;
void    D_glClearStencil( GLint s ) ;
void    D_glTexGend( GLenum coord, GLenum pname, GLdouble param ) ;
void    D_glTexGenf( GLenum coord, GLenum pname, GLfloat param ) ;
void    D_glTexGeni( GLenum coord, GLenum pname, GLint param ) ;
void    D_glTexGendv( GLenum coord, GLenum pname, GLdouble *params ) ;
void    D_glTexGenfv( GLenum coord, GLenum pname, GLfloat *params ) ;
void    D_glTexGeniv( GLenum coord, GLenum pname, GLint *params ) ;
void    D_glGetTexGendv( GLenum coord, GLenum pname, GLdouble *params ) ;
void    D_glGetTexGenfv( GLenum coord, GLenum pname, GLfloat *params ) ;
void    D_glGetTexGeniv( GLenum coord, GLenum pname, GLint *params ) ;
void    D_glTexEnvf( GLenum target, GLenum pname, GLfloat param ) ;
void    D_glTexEnvi( GLenum target, GLenum pname, GLint param ) ;
void    D_glTexEnvfv( GLenum target, GLenum pname, GLfloat *params ) ;
void    D_glTexEnviv( GLenum target, GLenum pname, GLint *params ) ;
void    D_glGetTexEnvfv( GLenum target, GLenum pname, GLfloat *params ) ;
void    D_glGetTexEnviv( GLenum target, GLenum pname, GLint *params ) ;
void    D_glTexParameterf( GLenum target, GLenum pname, GLfloat param ) ;
void    D_glTexParameteri( GLenum target, GLenum pname, GLint param ) ;
void    D_glTexParameterfv( GLenum target, GLenum pname, GLfloat *params ) ;
void    D_glTexParameteriv( GLenum target, GLenum pname, GLint *params ) ;
void    D_glGetTexParameterfv( GLenum target, GLenum pname, GLfloat *params) ;
void    D_glGetTexParameteriv( GLenum target, GLenum pname, GLint *params ) ;
void    D_glGetTexLevelParameterfv( GLenum target, GLint level, GLenum pname, GLfloat *params ) ;
void    D_glGetTexLevelParameteriv( GLenum target, GLint level, GLenum pname, GLint *params ) ;
void    D_glTexImage1D( GLenum target, GLint level, GLint internalFormat, GLsizei width, GLint border, GLenum format, GLenum type, GLvoid *pixels ) ;
void    D_glTexImage2D( GLenum target, GLint level, GLint internalFormat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, GLvoid *pixels ) ;
void    D_glGetTexImage( GLenum target, GLint level, GLenum format, GLenum type, GLvoid *pixels ) ;
void    D_glMap1d( GLenum target, GLdouble u1, GLdouble u2, GLint stride, GLint order, GLdouble *points ) ;
void    D_glMap1f( GLenum target, GLfloat u1, GLfloat u2, GLint stride, GLint order, GLfloat *points ) ;
void    D_glMap2d( GLenum target, GLdouble u1, GLdouble u2, GLint ustride, GLint uorder, GLdouble v1, GLdouble v2, GLint vstride, GLint vorder, GLdouble *points ) ;
void    D_glMap2f( GLenum target, GLfloat u1, GLfloat u2, GLint ustride, GLint uorder, GLfloat v1, GLfloat v2, GLint vstride, GLint vorder, GLfloat *points ) ;
void    D_glGetMapdv( GLenum target, GLenum query, GLdouble *v ) ;
void    D_glGetMapfv( GLenum target, GLenum query, GLfloat *v ) ;
void    D_glGetMapiv( GLenum target, GLenum query, GLint *v ) ;
void    D_glEvalCoord1d( GLdouble u ) ;
void    D_glEvalCoord1f( GLfloat u ) ;
void    D_glEvalCoord1dv( GLdouble *u ) ;
void    D_glEvalCoord1fv( GLfloat *u ) ;
void    D_glEvalCoord2d( GLdouble u, GLdouble v ) ;
void    D_glEvalCoord2f( GLfloat u, GLfloat v ) ;
void    D_glEvalCoord2dv( GLdouble *u ) ;
void    D_glEvalCoord2fv( GLfloat *u ) ;
void    D_glMapGrid1d( GLint un, GLdouble u1, GLdouble u2 ) ;
void    D_glMapGrid1f( GLint un, GLfloat u1, GLfloat u2 ) ;
void    D_glMapGrid2d( GLint un, GLdouble u1, GLdouble u2, GLint vn, GLdouble v1, GLdouble v2 ) ;
void    D_glMapGrid2f( GLint un, GLfloat u1, GLfloat u2, GLint vn, GLfloat v1, GLfloat v2 ) ;
void    D_glEvalPoint1( GLint i ) ;
void    D_glEvalPoint2( GLint i, GLint j ) ;
void    D_glEvalMesh1( GLenum mode, GLint i1, GLint i2 ) ;
void    D_glEvalMesh2( GLenum mode, GLint i1, GLint i2, GLint j1, GLint j2 ) ;
void    D_glFogf( GLenum pname, GLfloat param ) ;
void    D_glFogi( GLenum pname, GLint param ) ;
void    D_glFogfv( GLenum pname, GLfloat *params ) ;
void    D_glFogiv( GLenum pname, GLint *params ) ;
void    D_glFeedbackBuffer( GLsizei size, GLenum type, GLfloat *buffer ) ;
void    D_glPassThrough( GLfloat token ) ;
void    D_glSelectBuffer( GLsizei size, GLuint *buffer ) ;
void    D_glInitNames() ;
void    D_glLoadName( GLuint name ) ;
void    D_glPushName( GLuint name ) ;
void    D_glPopName() ;
void    D_glGenTextures( GLsizei n, GLuint *textures ) ;
void    D_glDeleteTextures( GLsizei n, GLuint *textures) ;
void    D_glBindTexture( GLenum target, GLuint texture ) ;
void    D_glPrioritizeTextures( GLsizei n, GLuint *textures, GLclampf *priorities ) ;
GLboolean  D_glAreTexturesResident( GLsizei n, GLuint *textures, GLboolean *residences ) ;
GLboolean  D_glIsTexture( GLuint texture ) ;
void    D_glTexSubImage1D( GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, GLvoid *pixels ) ;
void    D_glTexSubImage2D( GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid *pixels ) ;
void    D_glCopyTexImage1D( GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLint border ) ;
void    D_glCopyTexImage2D( GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border ) ;
void    D_glCopyTexSubImage1D( GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width ) ;
void    D_glCopyTexSubImage2D( GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height ) ;
void    D_glVertexPointer( GLint size, GLenum type, GLsizei stride, GLvoid *ptr ) ;
void    D_glNormalPointer( GLenum type, GLsizei stride, GLvoid *ptr ) ;
void    D_glColorPointer( GLint size, GLenum type, GLsizei stride, GLvoid *ptr ) ;
void    D_glIndexPointer( GLenum type, GLsizei stride, GLvoid *ptr ) ;
void    D_glTexCoordPointer( GLint size, GLenum type, GLsizei stride, GLvoid *ptr ) ;
void    D_glEdgeFlagPointer( GLsizei stride, GLvoid *ptr ) ;
void    D_glGetPointerv( GLenum pname, GLvoid **params ) ;
void    D_glArrayElement( GLint i ) ;
void    D_glDrawArrays( GLenum mode, GLint first, GLsizei count ) ;
void    D_glDrawElements( GLenum mode, GLsizei count, GLenum type, GLvoid *indices ) ;
void    D_glInterleavedArrays( GLenum format, GLsizei stride, GLvoid *pointer ) ;
void    D_gluBeginCurve (GLUnurbs* nurb) ;
void    D_gluBeginPolygon (GLUtesselator* tess) ;
void    D_gluBeginSurface (GLUnurbs* nurb) ;
void    D_gluBeginTrim (GLUnurbs* nurb) ;
GLint   D_gluBuild1DMipmaps (GLenum target, GLint internalFormat, GLsizei width, GLenum format, GLenum type, void *data) ;
GLint   D_gluBuild2DMipmaps (GLenum target, GLint internalFormat, GLsizei width, GLsizei height, GLenum format, GLenum type, void *data) ;
void    D_gluCylinder (GLUquadric* quad, GLdouble base, GLdouble top, GLdouble height, GLint slices, GLint stacks) ;
void    D_gluDeleteNurbsRenderer (GLUnurbs* nurb) ;
void    D_gluDeleteQuadric (GLUquadric* quad) ;
void    D_gluDeleteTess (GLUtesselator* tess) ;
void    D_gluDisk (GLUquadric* quad, GLdouble inner, GLdouble outer, GLint slices, GLint loops) ;
void    D_gluEndCurve (GLUnurbs* nurb) ;
void    D_gluEndPolygon (GLUtesselator* tess) ;
void    D_gluEndSurface (GLUnurbs* nurb) ;
void    D_gluEndTrim (GLUnurbs* nurb) ;
GLubyte*  D_gluErrorString (GLenum error) ;
wchar*    D_gluErrorUnicodeStringEXT (GLenum error) ;
void    D_gluGetNurbsProperty (GLUnurbs* nurb, GLenum property, GLfloat* data) ;
GLubyte *  D_gluGetString (GLenum name) ;
void    D_gluGetTessProperty (GLUtesselator* tess, GLenum which, GLdouble* data) ;
void    D_gluLoadSamplingMatrices (GLUnurbs* nurb, GLfloat *model, GLfloat *perspective, GLint *view) ;
void    D_gluLookAt (GLdouble eyeX, GLdouble eyeY, GLdouble eyeZ, GLdouble centerX, GLdouble centerY, GLdouble centerZ, GLdouble upX, GLdouble upY, GLdouble upZ) ;
GLUnurbs*  D_gluNewNurbsRenderer () ;
GLUquadric*  D_gluNewQuadric () ;
GLUtesselator*  D_gluNewTess () ;
void    D_gluNextContour (GLUtesselator* tess, GLenum type) ;
void    D_gluNurbsCallback (GLUnurbs* nurb, GLenum which, void (*fn)()) ;
void    D_gluNurbsCurve (GLUnurbs* nurb, GLint knotCount, GLfloat *knots, GLint stride, GLfloat *control, GLint order, GLenum type) ;
void    D_gluNurbsProperty (GLUnurbs* nurb, GLenum property, GLfloat value) ;
void    D_gluNurbsSurface (GLUnurbs* nurb, GLint sKnotCount, GLfloat* sKnots, GLint tKnotCount, GLfloat* tKnots, GLint sStride, GLint tStride, GLfloat* control, GLint sOrder, GLint tOrder, GLenum type) ;
void    D_gluOrtho2D (GLdouble left, GLdouble right, GLdouble bottom, GLdouble top) ;
void    D_gluPartialDisk (GLUquadric* quad, GLdouble inner, GLdouble outer, GLint slices, GLint loops, GLdouble start, GLdouble sweep) ;
void    D_gluPerspective (GLdouble fovy, GLdouble aspect, GLdouble zNear, GLdouble zFar) ;
void    D_gluPickMatrix (GLdouble x, GLdouble y, GLdouble delX, GLdouble delY, GLint *viewport) ;
GLint   D_gluProject (GLdouble objX, GLdouble objY, GLdouble objZ, GLdouble *model, GLdouble *proj, GLint *view, GLdouble* winX, GLdouble* winY, GLdouble* winZ) ;
void    D_gluPwlCurve (GLUnurbs* nurb, GLint count, GLfloat* data, GLint stride, GLenum type) ;
void    D_gluQuadricCallback (GLUquadric* quad, GLenum which, void (* fn)()) ;
void    D_gluQuadricDrawStyle (GLUquadric* quad, GLenum draw) ;
void    D_gluQuadricNormals (GLUquadric* quad, GLenum normal) ;
void    D_gluQuadricOrientation (GLUquadric* quad, GLenum orientation) ;
void    D_gluQuadricTexture (GLUquadric* quad, GLboolean texture) ;
GLint   D_gluScaleImage (GLenum format, GLsizei wIn, GLsizei hIn, GLenum typeIn, void *dataIn, GLsizei wOut, GLsizei hOut, GLenum typeOut, GLvoid* dataOut) ;
void    D_gluSphere (GLUquadric* quad, GLdouble radius, GLint slices, GLint stacks) ;
void    D_gluTessBeginContour (GLUtesselator* tess) ;
void    D_gluTessBeginPolygon (GLUtesselator* tess, GLvoid* data) ;
void    D_gluTessCallback (GLUtesselator* tess, GLenum which, void (* fn)()) ;
void    D_gluTessEndContour (GLUtesselator* tess) ;
void    D_gluTessEndPolygon (GLUtesselator* tess) ;
void    D_gluTessNormal (GLUtesselator* tess, GLdouble valueX, GLdouble valueY, GLdouble valueZ) ;
void    D_gluTessProperty (GLUtesselator* tess, GLenum which, GLdouble data) ;
void    D_gluTessVertex (GLUtesselator* tess, GLdouble *location, GLvoid* data) ;
GLint   D_gluUnProject (GLdouble winX, GLdouble winY, GLdouble winZ, GLdouble *model, GLdouble *proj, GLint *view, GLdouble* objX, GLdouble* objY, GLdouble* objZ) ;
void    D_glutInit(int *argcp, char **argv) ;
void    D_glutInitDisplayMode(uint mode) ;
void    D_glutInitDisplayString(char *string) ;
void    D_glutInitWindowPosition(int x, int y) ;
void    D_glutInitWindowSize(int width, int height) ;
void    D_glutMainLoop() ;
int     D_glutCreateWindow(char *title) ;
int     D_glutCreateSubWindow(int win, int x, int y, int width, int height) ;
void    D_glutDestroyWindow(int win) ;
void    D_glutPostRedisplay() ;
void    D_glutPostWindowRedisplay(int win) ;
void    D_glutSwapBuffers() ;
int     D_glutGetWindow() ;
void    D_glutSetWindow(int win) ;
void    D_glutSetWindowTitle(char *title) ;
void    D_glutSetIconTitle(char *title) ;
void    D_glutPositionWindow(int x, int y) ;
void    D_glutReshapeWindow(int width, int height) ;
void    D_glutPopWindow() ;
void    D_glutPushWindow() ;
void    D_glutIconifyWindow() ;
void    D_glutShowWindow() ;
void    D_glutHideWindow() ;
void    D_glutFullScreen() ;
void    D_glutSetCursor(int cursor) ;
void    D_glutWarpPointer(int x, int y) ;
void    D_glutEstablishOverlay() ;
void    D_glutRemoveOverlay() ;
void    D_glutUseLayer(GLenum layer) ;
void    D_glutPostOverlayRedisplay() ;
void    D_glutPostWindowOverlayRedisplay(int win) ;
void    D_glutShowOverlay() ;
void    D_glutHideOverlay() ;
int     D_glutCreateMenu(void  (*func)(int)) ;
void    D_glutDestroyMenu(int menu) ;
int     D_glutGetMenu() ;
void    D_glutSetMenu(int menu) ;
void    D_glutAddMenuEntry(char *label, int value) ;
void    D_glutAddSubMenu(char *label, int submenu) ;
void    D_glutChangeToMenuEntry(int item, char *label, int value) ;
void    D_glutChangeToSubMenu(int item, char *label, int submenu) ;
void    D_glutRemoveMenuItem(int item) ;
void    D_glutAttachMenu(int button) ;
void    D_glutDetachMenu(int button) ;
void    D_glutDisplayFunc(void  (*func)()) ;
void    D_glutReshapeFunc(void  (*func)(int width, int height)) ;
void    D_glutKeyboardFunc(void  (*func)(uchar key, int x, int y)) ;
void    D_glutMouseFunc(void  (*func)(int button, int state, int x, int y)) ;
void    D_glutMotionFunc(void  (*func)(int x, int y)) ;
void    D_glutPassiveMotionFunc(void  (*func)(int x, int y)) ;
void    D_glutEntryFunc(void  (*func)(int state)) ;
void    D_glutVisibilityFunc(void  (*func)(int state)) ;
void    D_glutIdleFunc(void  (*func)()) ;
void    D_glutTimerFunc(uint millis, void  (*func)(int value), int value) ;
void    D_glutMenuStateFunc(void  (*func)(int state)) ;
void    D_glutSpecialFunc(void  (*func)(int key, int x, int y)) ;
void    D_glutSpaceballMotionFunc(void  (*func)(int x, int y, int z)) ;
void    D_glutSpaceballRotateFunc(void  (*func)(int x, int y, int z)) ;
void    D_glutSpaceballButtonFunc(void  (*func)(int button, int state)) ;
void    D_glutButtonBoxFunc(void  (*func)(int button, int state)) ;
void    D_glutDialsFunc(void  (*func)(int dial, int value)) ;
void    D_glutTabletMotionFunc(void  (*func)(int x, int y)) ;
void    D_glutTabletButtonFunc(void  (*func)(int button, int state, int x, int y)) ;
void    D_glutMenuStatusFunc(void  (*func)(int status, int x, int y)) ;
void    D_glutOverlayDisplayFunc(void  (*func)()) ;
void    D_glutWindowStatusFunc(void  (*func)(int state)) ;
void    D_glutKeyboardUpFunc(void  (*func)(uchar key, int x, int y)) ;
void    D_glutSpecialUpFunc(void  (*func)(int key, int x, int y)) ;
void    D_glutJoystickFunc(void  (*func)(uint buttonMask, int x, int y, int z), int pollInterval) ;
void    D_glutSetColor(int cell, GLfloat red, GLfloat green, GLfloat blue) ;
GLfloat  D_glutGetColor(int ndx, int component) ;
void    D_glutCopyColormap(int win) ;
int     D_glutGet(GLenum type) ;
int     D_glutDeviceGet(GLenum type) ;
int     D_glutExtensionSupported(char *name) ;
int     D_glutGetModifiers() ;
int     D_glutLayerGet(GLenum type) ;
void    D_glutBitmapCharacter(void *font, int character) ;
int     D_glutBitmapWidth(void *font, int character) ;
void    D_glutStrokeCharacter(void *font, int character) ;
int     D_glutStrokeWidth(void *font, int character) ;
int     D_glutBitmapLength(void *font, uchar *string) ;
int     D_glutStrokeLength(void *font, uchar *string) ;
void    D_glutWireSphere(GLdouble radius, GLint slices, GLint stacks) ;
void    D_glutSolidSphere(GLdouble radius, GLint slices, GLint stacks) ;
void    D_glutWireCone(GLdouble base, GLdouble height, GLint slices, GLint stacks) ;
void    D_glutSolidCone(GLdouble base, GLdouble height, GLint slices, GLint stacks) ;
void    D_glutWireCube(GLdouble size) ;
void    D_glutSolidCube(GLdouble size) ;
void    D_glutWireTorus(GLdouble innerRadius, GLdouble outerRadius, GLint sides, GLint rings) ;
void    D_glutSolidTorus(GLdouble innerRadius, GLdouble outerRadius, GLint sides, GLint rings) ;
void    D_glutWireDodecahedron() ;
void    D_glutSolidDodecahedron() ;
void    D_glutWireTeapot(GLdouble size) ;
void    D_glutSolidTeapot(GLdouble size) ;
void    D_glutWireOctahedron() ;
void    D_glutSolidOctahedron() ;
void    D_glutWireTetrahedron() ;
void    D_glutSolidTetrahedron() ;
void    D_glutWireIcosahedron() ;
void    D_glutSolidIcosahedron() ;
int     D_glutVideoResizeGet(GLenum param) ;
void    D_glutSetupVideoResizing() ;
void    D_glutStopVideoResizing() ;
void    D_glutVideoResize(int x, int y, int width, int height) ;
void    D_glutVideoPan(int x, int y, int width, int height) ;
void    D_glutReportErrors() ;
void    D_glutIgnoreKeyRepeat(int ignore) ;
void    D_glutSetKeyRepeat(int repeatMode) ;
void    D_glutForceJoystickFunc() ;
void    D_glutGameModeString(char *string) ;
int     D_glutEnterGameMode() ;
void    D_glutLeaveGameMode() ;
int     D_glutGameModeGet(GLenum mode) ;

const uint GL_VERSION_1_1                            =  1;
const uint GL_ACCUM                                  =  0x0100;
const uint GL_LOAD                                   =  0x0101;
const uint GL_RETURN                                 =  0x0102;
const uint GL_MULT                                   =  0x0103;
const uint GL_ADD                                    =  0x0104;
const uint GL_NEVER                                  =  0x0200;
const uint GL_LESS                                   =  0x0201;
const uint GL_EQUAL                                  =  0x0202;
const uint GL_LEQUAL                                 =  0x0203;
const uint GL_GREATER                                =  0x0204;
const uint GL_NOTEQUAL                               =  0x0205;
const uint GL_GEQUAL                                 =  0x0206;
const uint GL_ALWAYS                                 =  0x0207;
const uint GL_CURRENT_BIT                            =  0x00000001;
const uint GL_POINT_BIT                              =  0x00000002;
const uint GL_LINE_BIT                               =  0x00000004;
const uint GL_POLYGON_BIT                            =  0x00000008;
const uint GL_POLYGON_STIPPLE_BIT                    =  0x00000010;
const uint GL_PIXEL_MODE_BIT                         =  0x00000020;
const uint GL_LIGHTING_BIT                           =  0x00000040;
const uint GL_FOG_BIT                                =  0x00000080;
const uint GL_DEPTH_BUFFER_BIT                       =  0x00000100;
const uint GL_ACCUM_BUFFER_BIT                       =  0x00000200;
const uint GL_STENCIL_BUFFER_BIT                     =  0x00000400;
const uint GL_VIEWPORT_BIT                           =  0x00000800;
const uint GL_TRANSFORM_BIT                          =  0x00001000;
const uint GL_ENABLE_BIT                             =  0x00002000;
const uint GL_COLOR_BUFFER_BIT                       =  0x00004000;
const uint GL_HINT_BIT                               =  0x00008000;
const uint GL_EVAL_BIT                               =  0x00010000;
const uint GL_LIST_BIT                               =  0x00020000;
const uint GL_TEXTURE_BIT                            =  0x00040000;
const uint GL_SCISSOR_BIT                            =  0x00080000;
const uint GL_ALL_ATTRIB_BITS                        =  0x000fffff;
const uint GL_POINTS                                 =  0x0000;
const uint GL_LINES                                  =  0x0001;
const uint GL_LINE_LOOP                              =  0x0002;
const uint GL_LINE_STRIP                             =  0x0003;
const uint GL_TRIANGLES                              =  0x0004;
const uint GL_TRIANGLE_STRIP                         =  0x0005;
const uint GL_TRIANGLE_FAN                           =  0x0006;
const uint GL_QUADS                                  =  0x0007;
const uint GL_QUAD_STRIP                             =  0x0008;
const uint GL_POLYGON                                =  0x0009;
const uint GL_ZERO                                   =  0;
const uint GL_ONE                                    =  1;
const uint GL_SRC_COLOR                              =  0x0300;
const uint GL_ONE_MINUS_SRC_COLOR                    =  0x0301;
const uint GL_SRC_ALPHA                              =  0x0302;
const uint GL_ONE_MINUS_SRC_ALPHA                    =  0x0303;
const uint GL_DST_ALPHA                              =  0x0304;
const uint GL_ONE_MINUS_DST_ALPHA                    =  0x0305;
const uint GL_DST_COLOR                              =  0x0306;
const uint GL_ONE_MINUS_DST_COLOR                    =  0x0307;
const uint GL_SRC_ALPHA_SATURATE                     =  0x0308;
const uint GL_TRUE                                   =  1;
const uint GL_FALSE                                  =  0;
const uint GL_CLIP_PLANE0                            =  0x3000;
const uint GL_CLIP_PLANE1                            =  0x3001;
const uint GL_CLIP_PLANE2                            =  0x3002;
const uint GL_CLIP_PLANE3                            =  0x3003;
const uint GL_CLIP_PLANE4                            =  0x3004;
const uint GL_CLIP_PLANE5                            =  0x3005;
const uint GL_BYTE                                   =  0x1400;
const uint GL_UNSIGNED_BYTE                          =  0x1401;
const uint GL_SHORT                                  =  0x1402;
const uint GL_UNSIGNED_SHORT                         =  0x1403;
const uint GL_INT                                    =  0x1404;
const uint GL_UNSIGNED_INT                           =  0x1405;
const uint GL_FLOAT                                  =  0x1406;
const uint GL_2_BYTES                                =  0x1407;
const uint GL_3_BYTES                                =  0x1408;
const uint GL_4_BYTES                                =  0x1409;
const uint GL_DOUBLE                                 =  0x140A;
const uint GL_NONE                                   =  0;
const uint GL_FRONT_LEFT                             =  0x0400;
const uint GL_FRONT_RIGHT                            =  0x0401;
const uint GL_BACK_LEFT                              =  0x0402;
const uint GL_BACK_RIGHT                             =  0x0403;
const uint GL_FRONT                                  =  0x0404;
const uint GL_BACK                                   =  0x0405;
const uint GL_LEFT                                   =  0x0406;
const uint GL_RIGHT                                  =  0x0407;
const uint GL_FRONT_AND_BACK                         =  0x0408;
const uint GL_AUX0                                   =  0x0409;
const uint GL_AUX1                                   =  0x040A;
const uint GL_AUX2                                   =  0x040B;
const uint GL_AUX3                                   =  0x040C;
const uint GL_NO_ERROR                               =  0;
const uint GL_INVALID_ENUM                           =  0x0500;
const uint GL_INVALID_VALUE                          =  0x0501;
const uint GL_INVALID_OPERATION                      =  0x0502;
const uint GL_STACK_OVERFLOW                         =  0x0503;
const uint GL_STACK_UNDERFLOW                        =  0x0504;
const uint GL_OUT_OF_MEMORY                          =  0x0505;
const uint GL_2D                                     =  0x0600;
const uint GL_3D                                     =  0x0601;
const uint GL_3D_COLOR                               =  0x0602;
const uint GL_3D_COLOR_TEXTURE                       =  0x0603;
const uint GL_4D_COLOR_TEXTURE                       =  0x0604;
const uint GL_PASS_THROUGH_TOKEN                     =  0x0700;
const uint GL_POINT_TOKEN                            =  0x0701;
const uint GL_LINE_TOKEN                             =  0x0702;
const uint GL_POLYGON_TOKEN                          =  0x0703;
const uint GL_BITMAP_TOKEN                           =  0x0704;
const uint GL_DRAW_PIXEL_TOKEN                       =  0x0705;
const uint GL_COPY_PIXEL_TOKEN                       =  0x0706;
const uint GL_LINE_RESET_TOKEN                       =  0x0707;
const uint GL_EXP                                    =  0x0800;
const uint GL_EXP2                                   =  0x0801;
const uint GL_CW                                     =  0x0900;
const uint GL_CCW                                    =  0x0901;
const uint GL_COEFF                                  =  0x0A00;
const uint GL_ORDER                                  =  0x0A01;
const uint GL_DOMAIN                                 =  0x0A02;
const uint GL_CURRENT_COLOR                          =  0x0B00;
const uint GL_CURRENT_INDEX                          =  0x0B01;
const uint GL_CURRENT_NORMAL                         =  0x0B02;
const uint GL_CURRENT_TEXTURE_COORDS                 =  0x0B03;
const uint GL_CURRENT_RASTER_COLOR                   =  0x0B04;
const uint GL_CURRENT_RASTER_INDEX                   =  0x0B05;
const uint GL_CURRENT_RASTER_TEXTURE_COORDS          =  0x0B06;
const uint GL_CURRENT_RASTER_POSITION                =  0x0B07;
const uint GL_CURRENT_RASTER_POSITION_VALID          =  0x0B08;
const uint GL_CURRENT_RASTER_DISTANCE                =  0x0B09;
const uint GL_POINT_SMOOTH                           =  0x0B10;
const uint GL_POINT_SIZE                             =  0x0B11;
const uint GL_POINT_SIZE_RANGE                       =  0x0B12;
const uint GL_POINT_SIZE_GRANULARITY                 =  0x0B13;
const uint GL_LINE_SMOOTH                            =  0x0B20;
const uint GL_LINE_WIDTH                             =  0x0B21;
const uint GL_LINE_WIDTH_RANGE                       =  0x0B22;
const uint GL_LINE_WIDTH_GRANULARITY                 =  0x0B23;
const uint GL_LINE_STIPPLE                           =  0x0B24;
const uint GL_LINE_STIPPLE_PATTERN                   =  0x0B25;
const uint GL_LINE_STIPPLE_REPEAT                    =  0x0B26;
const uint GL_LIST_MODE                              =  0x0B30;
const uint GL_MAX_LIST_NESTING                       =  0x0B31;
const uint GL_LIST_BASE                              =  0x0B32;
const uint GL_LIST_INDEX                             =  0x0B33;
const uint GL_POLYGON_MODE                           =  0x0B40;
const uint GL_POLYGON_SMOOTH                         =  0x0B41;
const uint GL_POLYGON_STIPPLE                        =  0x0B42;
const uint GL_EDGE_FLAG                              =  0x0B43;
const uint GL_CULL_FACE                              =  0x0B44;
const uint GL_CULL_FACE_MODE                         =  0x0B45;
const uint GL_FRONT_FACE                             =  0x0B46;
const uint GL_LIGHTING                               =  0x0B50;
const uint GL_LIGHT_MODEL_LOCAL_VIEWER               =  0x0B51;
const uint GL_LIGHT_MODEL_TWO_SIDE                   =  0x0B52;
const uint GL_LIGHT_MODEL_AMBIENT                    =  0x0B53;
const uint GL_SHADE_MODEL                            =  0x0B54;
const uint GL_COLOR_MATERIAL_FACE                    =  0x0B55;
const uint GL_COLOR_MATERIAL_PARAMETER               =  0x0B56;
const uint GL_COLOR_MATERIAL                         =  0x0B57;
const uint GL_FOG                                    =  0x0B60;
const uint GL_FOG_INDEX                              =  0x0B61;
const uint GL_FOG_DENSITY                            =  0x0B62;
const uint GL_FOG_START                              =  0x0B63;
const uint GL_FOG_END                                =  0x0B64;
const uint GL_FOG_MODE                               =  0x0B65;
const uint GL_FOG_COLOR                              =  0x0B66;
const uint GL_DEPTH_RANGE                            =  0x0B70;
const uint GL_DEPTH_TEST                             =  0x0B71;
const uint GL_DEPTH_WRITEMASK                        =  0x0B72;
const uint GL_DEPTH_CLEAR_VALUE                      =  0x0B73;
const uint GL_DEPTH_FUNC                             =  0x0B74;
const uint GL_ACCUM_CLEAR_VALUE                      =  0x0B80;
const uint GL_STENCIL_TEST                           =  0x0B90;
const uint GL_STENCIL_CLEAR_VALUE                    =  0x0B91;
const uint GL_STENCIL_FUNC                           =  0x0B92;
const uint GL_STENCIL_VALUE_MASK                     =  0x0B93;
const uint GL_STENCIL_FAIL                           =  0x0B94;
const uint GL_STENCIL_PASS_DEPTH_FAIL                =  0x0B95;
const uint GL_STENCIL_PASS_DEPTH_PASS                =  0x0B96;
const uint GL_STENCIL_REF                            =  0x0B97;
const uint GL_STENCIL_WRITEMASK                      =  0x0B98;
const uint GL_MATRIX_MODE                            =  0x0BA0;
const uint GL_NORMALIZE                              =  0x0BA1;
const uint GL_VIEWPORT                               =  0x0BA2;
const uint GL_MODELVIEW_STACK_DEPTH                  =  0x0BA3;
const uint GL_PROJECTION_STACK_DEPTH                 =  0x0BA4;
const uint GL_TEXTURE_STACK_DEPTH                    =  0x0BA5;
const uint GL_MODELVIEW_MATRIX                       =  0x0BA6;
const uint GL_PROJECTION_MATRIX                      =  0x0BA7;
const uint GL_TEXTURE_MATRIX                         =  0x0BA8;
const uint GL_ATTRIB_STACK_DEPTH                     =  0x0BB0;
const uint GL_CLIENT_ATTRIB_STACK_DEPTH              =  0x0BB1;
const uint GL_ALPHA_TEST                             =  0x0BC0;
const uint GL_ALPHA_TEST_FUNC                        =  0x0BC1;
const uint GL_ALPHA_TEST_REF                         =  0x0BC2;
const uint GL_DITHER                                 =  0x0BD0;
const uint GL_BLEND_DST                              =  0x0BE0;
const uint GL_BLEND_SRC                              =  0x0BE1;
const uint GL_BLEND                                  =  0x0BE2;
const uint GL_LOGIC_OP_MODE                          =  0x0BF0;
const uint GL_INDEX_LOGIC_OP                         =  0x0BF1;
const uint GL_COLOR_LOGIC_OP                         =  0x0BF2;
const uint GL_AUX_BUFFERS                            =  0x0C00;
const uint GL_DRAW_BUFFER                            =  0x0C01;
const uint GL_READ_BUFFER                            =  0x0C02;
const uint GL_SCISSOR_BOX                            =  0x0C10;
const uint GL_SCISSOR_TEST                           =  0x0C11;
const uint GL_INDEX_CLEAR_VALUE                      =  0x0C20;
const uint GL_INDEX_WRITEMASK                        =  0x0C21;
const uint GL_COLOR_CLEAR_VALUE                      =  0x0C22;
const uint GL_COLOR_WRITEMASK                        =  0x0C23;
const uint GL_INDEX_MODE                             =  0x0C30;
const uint GL_RGBA_MODE                              =  0x0C31;
const uint GL_DOUBLEBUFFER                           =  0x0C32;
const uint GL_STEREO                                 =  0x0C33;
const uint GL_RENDER_MODE                            =  0x0C40;
const uint GL_PERSPECTIVE_CORRECTION_HINT            =  0x0C50;
const uint GL_POINT_SMOOTH_HINT                      =  0x0C51;
const uint GL_LINE_SMOOTH_HINT                       =  0x0C52;
const uint GL_POLYGON_SMOOTH_HINT                    =  0x0C53;
const uint GL_FOG_HINT                               =  0x0C54;
const uint GL_TEXTURE_GEN_S                          =  0x0C60;
const uint GL_TEXTURE_GEN_T                          =  0x0C61;
const uint GL_TEXTURE_GEN_R                          =  0x0C62;
const uint GL_TEXTURE_GEN_Q                          =  0x0C63;
const uint GL_PIXEL_MAP_I_TO_I                       =  0x0C70;
const uint GL_PIXEL_MAP_S_TO_S                       =  0x0C71;
const uint GL_PIXEL_MAP_I_TO_R                       =  0x0C72;
const uint GL_PIXEL_MAP_I_TO_G                       =  0x0C73;
const uint GL_PIXEL_MAP_I_TO_B                       =  0x0C74;
const uint GL_PIXEL_MAP_I_TO_A                       =  0x0C75;
const uint GL_PIXEL_MAP_R_TO_R                       =  0x0C76;
const uint GL_PIXEL_MAP_G_TO_G                       =  0x0C77;
const uint GL_PIXEL_MAP_B_TO_B                       =  0x0C78;
const uint GL_PIXEL_MAP_A_TO_A                       =  0x0C79;
const uint GL_PIXEL_MAP_I_TO_I_SIZE                  =  0x0CB0;
const uint GL_PIXEL_MAP_S_TO_S_SIZE                  =  0x0CB1;
const uint GL_PIXEL_MAP_I_TO_R_SIZE                  =  0x0CB2;
const uint GL_PIXEL_MAP_I_TO_G_SIZE                  =  0x0CB3;
const uint GL_PIXEL_MAP_I_TO_B_SIZE                  =  0x0CB4;
const uint GL_PIXEL_MAP_I_TO_A_SIZE                  =  0x0CB5;
const uint GL_PIXEL_MAP_R_TO_R_SIZE                  =  0x0CB6;
const uint GL_PIXEL_MAP_G_TO_G_SIZE                  =  0x0CB7;
const uint GL_PIXEL_MAP_B_TO_B_SIZE                  =  0x0CB8;
const uint GL_PIXEL_MAP_A_TO_A_SIZE                  =  0x0CB9;
const uint GL_UNPACK_SWAP_BYTES                      =  0x0CF0;
const uint GL_UNPACK_LSB_FIRST                       =  0x0CF1;
const uint GL_UNPACK_ROW_LENGTH                      =  0x0CF2;
const uint GL_UNPACK_SKIP_ROWS                       =  0x0CF3;
const uint GL_UNPACK_SKIP_PIXELS                     =  0x0CF4;
const uint GL_UNPACK_ALIGNMENT                       =  0x0CF5;
const uint GL_PACK_SWAP_BYTES                        =  0x0D00;
const uint GL_PACK_LSB_FIRST                         =  0x0D01;
const uint GL_PACK_ROW_LENGTH                        =  0x0D02;
const uint GL_PACK_SKIP_ROWS                         =  0x0D03;
const uint GL_PACK_SKIP_PIXELS                       =  0x0D04;
const uint GL_PACK_ALIGNMENT                         =  0x0D05;
const uint GL_MAP_COLOR                              =  0x0D10;
const uint GL_MAP_STENCIL                            =  0x0D11;
const uint GL_INDEX_SHIFT                            =  0x0D12;
const uint GL_INDEX_OFFSET                           =  0x0D13;
const uint GL_RED_SCALE                              =  0x0D14;
const uint GL_RED_BIAS                               =  0x0D15;
const uint GL_ZOOM_X                                 =  0x0D16;
const uint GL_ZOOM_Y                                 =  0x0D17;
const uint GL_GREEN_SCALE                            =  0x0D18;
const uint GL_GREEN_BIAS                             =  0x0D19;
const uint GL_BLUE_SCALE                             =  0x0D1A;
const uint GL_BLUE_BIAS                              =  0x0D1B;
const uint GL_ALPHA_SCALE                            =  0x0D1C;
const uint GL_ALPHA_BIAS                             =  0x0D1D;
const uint GL_DEPTH_SCALE                            =  0x0D1E;
const uint GL_DEPTH_BIAS                             =  0x0D1F;
const uint GL_MAX_EVAL_ORDER                         =  0x0D30;
const uint GL_MAX_LIGHTS                             =  0x0D31;
const uint GL_MAX_CLIP_PLANES                        =  0x0D32;
const uint GL_MAX_TEXTURE_SIZE                       =  0x0D33;
const uint GL_MAX_PIXEL_MAP_TABLE                    =  0x0D34;
const uint GL_MAX_ATTRIB_STACK_DEPTH                 =  0x0D35;
const uint GL_MAX_MODELVIEW_STACK_DEPTH              =  0x0D36;
const uint GL_MAX_NAME_STACK_DEPTH                   =  0x0D37;
const uint GL_MAX_PROJECTION_STACK_DEPTH             =  0x0D38;
const uint GL_MAX_TEXTURE_STACK_DEPTH                =  0x0D39;
const uint GL_MAX_VIEWPORT_DIMS                      =  0x0D3A;
const uint GL_MAX_CLIENT_ATTRIB_STACK_DEPTH          =  0x0D3B;
const uint GL_SUBPIXEL_BITS                          =  0x0D50;
const uint GL_INDEX_BITS                             =  0x0D51;
const uint GL_RED_BITS                               =  0x0D52;
const uint GL_GREEN_BITS                             =  0x0D53;
const uint GL_BLUE_BITS                              =  0x0D54;
const uint GL_ALPHA_BITS                             =  0x0D55;
const uint GL_DEPTH_BITS                             =  0x0D56;
const uint GL_STENCIL_BITS                           =  0x0D57;
const uint GL_ACCUM_RED_BITS                         =  0x0D58;
const uint GL_ACCUM_GREEN_BITS                       =  0x0D59;
const uint GL_ACCUM_BLUE_BITS                        =  0x0D5A;
const uint GL_ACCUM_ALPHA_BITS                       =  0x0D5B;
const uint GL_NAME_STACK_DEPTH                       =  0x0D70;
const uint GL_AUTO_NORMAL                            =  0x0D80;
const uint GL_MAP1_COLOR_4                           =  0x0D90;
const uint GL_MAP1_INDEX                             =  0x0D91;
const uint GL_MAP1_NORMAL                            =  0x0D92;
const uint GL_MAP1_TEXTURE_COORD_1                   =  0x0D93;
const uint GL_MAP1_TEXTURE_COORD_2                   =  0x0D94;
const uint GL_MAP1_TEXTURE_COORD_3                   =  0x0D95;
const uint GL_MAP1_TEXTURE_COORD_4                   =  0x0D96;
const uint GL_MAP1_VERTEX_3                          =  0x0D97;
const uint GL_MAP1_VERTEX_4                          =  0x0D98;
const uint GL_MAP2_COLOR_4                           =  0x0DB0;
const uint GL_MAP2_INDEX                             =  0x0DB1;
const uint GL_MAP2_NORMAL                            =  0x0DB2;
const uint GL_MAP2_TEXTURE_COORD_1                   =  0x0DB3;
const uint GL_MAP2_TEXTURE_COORD_2                   =  0x0DB4;
const uint GL_MAP2_TEXTURE_COORD_3                   =  0x0DB5;
const uint GL_MAP2_TEXTURE_COORD_4                   =  0x0DB6;
const uint GL_MAP2_VERTEX_3                          =  0x0DB7;
const uint GL_MAP2_VERTEX_4                          =  0x0DB8;
const uint GL_MAP1_GRID_DOMAIN                       =  0x0DD0;
const uint GL_MAP1_GRID_SEGMENTS                     =  0x0DD1;
const uint GL_MAP2_GRID_DOMAIN                       =  0x0DD2;
const uint GL_MAP2_GRID_SEGMENTS                     =  0x0DD3;
const uint GL_TEXTURE_1D                             =  0x0DE0;
const uint GL_TEXTURE_2D                             =  0x0DE1;
const uint GL_FEEDBACK_BUFFER_POINTER                =  0x0DF0;
const uint GL_FEEDBACK_BUFFER_SIZE                   =  0x0DF1;
const uint GL_FEEDBACK_BUFFER_TYPE                   =  0x0DF2;
const uint GL_SELECTION_BUFFER_POINTER               =  0x0DF3;
const uint GL_SELECTION_BUFFER_SIZE                  =  0x0DF4;
const uint GL_TEXTURE_WIDTH                          =  0x1000;
const uint GL_TEXTURE_HEIGHT                         =  0x1001;
const uint GL_TEXTURE_INTERNAL_FORMAT                =  0x1003;
const uint GL_TEXTURE_BORDER_COLOR                   =  0x1004;
const uint GL_TEXTURE_BORDER                         =  0x1005;
const uint GL_DONT_CARE                              =  0x1100;
const uint GL_FASTEST                                =  0x1101;
const uint GL_NICEST                                 =  0x1102;
const uint GL_LIGHT0                                 =  0x4000;
const uint GL_LIGHT1                                 =  0x4001;
const uint GL_LIGHT2                                 =  0x4002;
const uint GL_LIGHT3                                 =  0x4003;
const uint GL_LIGHT4                                 =  0x4004;
const uint GL_LIGHT5                                 =  0x4005;
const uint GL_LIGHT6                                 =  0x4006;
const uint GL_LIGHT7                                 =  0x4007;
const uint GL_AMBIENT                                =  0x1200;
const uint GL_DIFFUSE                                =  0x1201;
const uint GL_SPECULAR                               =  0x1202;
const uint GL_POSITION                               =  0x1203;
const uint GL_SPOT_DIRECTION                         =  0x1204;
const uint GL_SPOT_EXPONENT                          =  0x1205;
const uint GL_SPOT_CUTOFF                            =  0x1206;
const uint GL_CONSTANT_ATTENUATION                   =  0x1207;
const uint GL_LINEAR_ATTENUATION                     =  0x1208;
const uint GL_QUADRATIC_ATTENUATION                  =  0x1209;
const uint GL_COMPILE                                =  0x1300;
const uint GL_COMPILE_AND_EXECUTE                    =  0x1301;
const uint GL_CLEAR                                  =  0x1500;
const uint GL_AND                                    =  0x1501;
const uint GL_AND_REVERSE                            =  0x1502;
const uint GL_COPY                                   =  0x1503;
const uint GL_AND_INVERTED                           =  0x1504;
const uint GL_NOOP                                   =  0x1505;
const uint GL_XOR                                    =  0x1506;
const uint GL_OR                                     =  0x1507;
const uint GL_NOR                                    =  0x1508;
const uint GL_EQUIV                                  =  0x1509;
const uint GL_INVERT                                 =  0x150A;
const uint GL_OR_REVERSE                             =  0x150B;
const uint GL_COPY_INVERTED                          =  0x150C;
const uint GL_OR_INVERTED                            =  0x150D;
const uint GL_NAND                                   =  0x150E;
const uint GL_SET                                    =  0x150F;
const uint GL_EMISSION                               =  0x1600;
const uint GL_SHININESS                              =  0x1601;
const uint GL_AMBIENT_AND_DIFFUSE                    =  0x1602;
const uint GL_COLOR_INDEXES                          =  0x1603;
const uint GL_MODELVIEW                              =  0x1700;
const uint GL_PROJECTION                             =  0x1701;
const uint GL_TEXTURE                                =  0x1702;
const uint GL_COLOR                                  =  0x1800;
const uint GL_DEPTH                                  =  0x1801;
const uint GL_STENCIL                                =  0x1802;
const uint GL_COLOR_INDEX                            =  0x1900;
const uint GL_STENCIL_INDEX                          =  0x1901;
const uint GL_DEPTH_COMPONENT                        =  0x1902;
const uint GL_RED                                    =  0x1903;
const uint GL_GREEN                                  =  0x1904;
const uint GL_BLUE                                   =  0x1905;
const uint GL_ALPHA                                  =  0x1906;
const uint GL_RGB                                    =  0x1907;
const uint GL_RGBA                                   =  0x1908;
const uint GL_LUMINANCE                              =  0x1909;
const uint GL_LUMINANCE_ALPHA                        =  0x190A;
const uint GL_BITMAP                                 =  0x1A00;
const uint GL_POINT                                  =  0x1B00;
const uint GL_LINE                                   =  0x1B01;
const uint GL_FILL                                   =  0x1B02;
const uint GL_RENDER                                 =  0x1C00;
const uint GL_FEEDBACK                               =  0x1C01;
const uint GL_SELECT                                 =  0x1C02;
const uint GL_FLAT                                   =  0x1D00;
const uint GL_SMOOTH                                 =  0x1D01;
const uint GL_KEEP                                   =  0x1E00;
const uint GL_REPLACE                                =  0x1E01;
const uint GL_INCR                                   =  0x1E02;
const uint GL_DECR                                   =  0x1E03;
const uint GL_VENDOR                                 =  0x1F00;
const uint GL_RENDERER                               =  0x1F01;
const uint GL_VERSION                                =  0x1F02;
const uint GL_EXTENSIONS                             =  0x1F03;
const uint GL_S                                      =  0x2000;
const uint GL_T                                      =  0x2001;
const uint GL_R                                      =  0x2002;
const uint GL_Q                                      =  0x2003;
const uint GL_MODULATE                               =  0x2100;
const uint GL_DECAL                                  =  0x2101;
const uint GL_TEXTURE_ENV_MODE                       =  0x2200;
const uint GL_TEXTURE_ENV_COLOR                      =  0x2201;
const uint GL_TEXTURE_ENV                            =  0x2300;
const uint GL_EYE_LINEAR                             =  0x2400;
const uint GL_OBJECT_LINEAR                          =  0x2401;
const uint GL_SPHERE_MAP                             =  0x2402;
const uint GL_TEXTURE_GEN_MODE                       =  0x2500;
const uint GL_OBJECT_PLANE                           =  0x2501;
const uint GL_EYE_PLANE                              =  0x2502;
const uint GL_NEAREST                                =  0x2600;
const uint GL_LINEAR                                 =  0x2601;
const uint GL_NEAREST_MIPMAP_NEAREST                 =  0x2700;
const uint GL_LINEAR_MIPMAP_NEAREST                  =  0x2701;
const uint GL_NEAREST_MIPMAP_LINEAR                  =  0x2702;
const uint GL_LINEAR_MIPMAP_LINEAR                   =  0x2703;
const uint GL_TEXTURE_MAG_FILTER                     =  0x2800;
const uint GL_TEXTURE_MIN_FILTER                     =  0x2801;
const uint GL_TEXTURE_WRAP_S                         =  0x2802;
const uint GL_TEXTURE_WRAP_T                         =  0x2803;
const uint GL_CLAMP                                  =  0x2900;
const uint GL_REPEAT                                 =  0x2901;
const uint GL_CLIENT_PIXEL_STORE_BIT                 =  0x00000001;
const uint GL_CLIENT_VERTEX_ARRAY_BIT                =  0x00000002;
const uint GL_CLIENT_ALL_ATTRIB_BITS                 =  0xffffffff;
const uint GL_POLYGON_OFFSET_FACTOR                  =  0x8038;
const uint GL_POLYGON_OFFSET_UNITS                   =  0x2A00;
const uint GL_POLYGON_OFFSET_POINT                   =  0x2A01;
const uint GL_POLYGON_OFFSET_LINE                    =  0x2A02;
const uint GL_POLYGON_OFFSET_FILL                    =  0x8037;
const uint GL_ALPHA4                                 =  0x803B;
const uint GL_ALPHA8                                 =  0x803C;
const uint GL_ALPHA12                                =  0x803D;
const uint GL_ALPHA16                                =  0x803E;
const uint GL_LUMINANCE4                             =  0x803F;
const uint GL_LUMINANCE8                             =  0x8040;
const uint GL_LUMINANCE12                            =  0x8041;
const uint GL_LUMINANCE16                            =  0x8042;
const uint GL_LUMINANCE4_ALPHA4                      =  0x8043;
const uint GL_LUMINANCE6_ALPHA2                      =  0x8044;
const uint GL_LUMINANCE8_ALPHA8                      =  0x8045;
const uint GL_LUMINANCE12_ALPHA4                     =  0x8046;
const uint GL_LUMINANCE12_ALPHA12                    =  0x8047;
const uint GL_LUMINANCE16_ALPHA16                    =  0x8048;
const uint GL_INTENSITY                              =  0x8049;
const uint GL_INTENSITY4                             =  0x804A;
const uint GL_INTENSITY8                             =  0x804B;
const uint GL_INTENSITY12                            =  0x804C;
const uint GL_INTENSITY16                            =  0x804D;
const uint GL_R3_G3_B2                               =  0x2A10;
const uint GL_RGB4                                   =  0x804F;
const uint GL_RGB5                                   =  0x8050;
const uint GL_RGB8                                   =  0x8051;
const uint GL_RGB10                                  =  0x8052;
const uint GL_RGB12                                  =  0x8053;
const uint GL_RGB16                                  =  0x8054;
const uint GL_RGBA2                                  =  0x8055;
const uint GL_RGBA4                                  =  0x8056;
const uint GL_RGB5_A1                                =  0x8057;
const uint GL_RGBA8                                  =  0x8058;
const uint GL_RGB10_A2                               =  0x8059;
const uint GL_RGBA12                                 =  0x805A;
const uint GL_RGBA16                                 =  0x805B;
const uint GL_TEXTURE_RED_SIZE                       =  0x805C;
const uint GL_TEXTURE_GREEN_SIZE                     =  0x805D;
const uint GL_TEXTURE_BLUE_SIZE                      =  0x805E;
const uint GL_TEXTURE_ALPHA_SIZE                     =  0x805F;
const uint GL_TEXTURE_LUMINANCE_SIZE                 =  0x8060;
const uint GL_TEXTURE_INTENSITY_SIZE                 =  0x8061;
const uint GL_PROXY_TEXTURE_1D                       =  0x8063;
const uint GL_PROXY_TEXTURE_2D                       =  0x8064;
const uint GL_TEXTURE_PRIORITY                       =  0x8066;
const uint GL_TEXTURE_RESIDENT                       =  0x8067;
const uint GL_TEXTURE_BINDING_1D                     =  0x8068;
const uint GL_TEXTURE_BINDING_2D                     =  0x8069;
const uint GL_VERTEX_ARRAY                           =  0x8074;
const uint GL_NORMAL_ARRAY                           =  0x8075;
const uint GL_COLOR_ARRAY                            =  0x8076;
const uint GL_INDEX_ARRAY                            =  0x8077;
const uint GL_TEXTURE_COORD_ARRAY                    =  0x8078;
const uint GL_EDGE_FLAG_ARRAY                        =  0x8079;
const uint GL_VERTEX_ARRAY_SIZE                      =  0x807A;
const uint GL_VERTEX_ARRAY_TYPE                      =  0x807B;
const uint GL_VERTEX_ARRAY_STRIDE                    =  0x807C;
const uint GL_NORMAL_ARRAY_TYPE                      =  0x807E;
const uint GL_NORMAL_ARRAY_STRIDE                    =  0x807F;
const uint GL_COLOR_ARRAY_SIZE                       =  0x8081;
const uint GL_COLOR_ARRAY_TYPE                       =  0x8082;
const uint GL_COLOR_ARRAY_STRIDE                     =  0x8083;
const uint GL_INDEX_ARRAY_TYPE                       =  0x8085;
const uint GL_INDEX_ARRAY_STRIDE                     =  0x8086;
const uint GL_TEXTURE_COORD_ARRAY_SIZE               =  0x8088;
const uint GL_TEXTURE_COORD_ARRAY_TYPE               =  0x8089;
const uint GL_TEXTURE_COORD_ARRAY_STRIDE             =  0x808A;
const uint GL_EDGE_FLAG_ARRAY_STRIDE                 =  0x808C;
const uint GL_VERTEX_ARRAY_POINTER                   =  0x808E;
const uint GL_NORMAL_ARRAY_POINTER                   =  0x808F;
const uint GL_COLOR_ARRAY_POINTER                    =  0x8090;
const uint GL_INDEX_ARRAY_POINTER                    =  0x8091;
const uint GL_TEXTURE_COORD_ARRAY_POINTER            =  0x8092;
const uint GL_EDGE_FLAG_ARRAY_POINTER                =  0x8093;
const uint GL_V2F                                    =  0x2A20;
const uint GL_V3F                                    =  0x2A21;
const uint GL_C4UB_V2F                               =  0x2A22;
const uint GL_C4UB_V3F                               =  0x2A23;
const uint GL_C3F_V3F                                =  0x2A24;
const uint GL_N3F_V3F                                =  0x2A25;
const uint GL_C4F_N3F_V3F                            =  0x2A26;
const uint GL_T2F_V3F                                =  0x2A27;
const uint GL_T4F_V4F                                =  0x2A28;
const uint GL_T2F_C4UB_V3F                           =  0x2A29;
const uint GL_T2F_C3F_V3F                            =  0x2A2A;
const uint GL_T2F_N3F_V3F                            =  0x2A2B;
const uint GL_T2F_C4F_N3F_V3F                        =  0x2A2C;
const uint GL_T4F_C4F_N3F_V4F                        =  0x2A2D;
const uint GL_EXT_vertex_array                       =  1;
const uint GL_EXT_bgra                               =  1;
const uint GL_EXT_paletted_texture                   =  1;
const uint GL_WIN_swap_hint                          =  1;
const uint GL_WIN_draw_range_elements                =  1;
const uint GL_VERTEX_ARRAY_EXT                       =  0x8074;
const uint GL_NORMAL_ARRAY_EXT                       =  0x8075;
const uint GL_COLOR_ARRAY_EXT                        =  0x8076;
const uint GL_INDEX_ARRAY_EXT                        =  0x8077;
const uint GL_TEXTURE_COORD_ARRAY_EXT                =  0x8078;
const uint GL_EDGE_FLAG_ARRAY_EXT                    =  0x8079;
const uint GL_VERTEX_ARRAY_SIZE_EXT                  =  0x807A;
const uint GL_VERTEX_ARRAY_TYPE_EXT                  =  0x807B;
const uint GL_VERTEX_ARRAY_STRIDE_EXT                =  0x807C;
const uint GL_VERTEX_ARRAY_COUNT_EXT                 =  0x807D;
const uint GL_NORMAL_ARRAY_TYPE_EXT                  =  0x807E;
const uint GL_NORMAL_ARRAY_STRIDE_EXT                =  0x807F;
const uint GL_NORMAL_ARRAY_COUNT_EXT                 =  0x8080;
const uint GL_COLOR_ARRAY_SIZE_EXT                   =  0x8081;
const uint GL_COLOR_ARRAY_TYPE_EXT                   =  0x8082;
const uint GL_COLOR_ARRAY_STRIDE_EXT                 =  0x8083;
const uint GL_COLOR_ARRAY_COUNT_EXT                  =  0x8084;
const uint GL_INDEX_ARRAY_TYPE_EXT                   =  0x8085;
const uint GL_INDEX_ARRAY_STRIDE_EXT                 =  0x8086;
const uint GL_INDEX_ARRAY_COUNT_EXT                  =  0x8087;
const uint GL_TEXTURE_COORD_ARRAY_SIZE_EXT           =  0x8088;
const uint GL_TEXTURE_COORD_ARRAY_TYPE_EXT           =  0x8089;
const uint GL_TEXTURE_COORD_ARRAY_STRIDE_EXT         =  0x808A;
const uint GL_TEXTURE_COORD_ARRAY_COUNT_EXT          =  0x808B;
const uint GL_EDGE_FLAG_ARRAY_STRIDE_EXT             =  0x808C;
const uint GL_EDGE_FLAG_ARRAY_COUNT_EXT              =  0x808D;
const uint GL_VERTEX_ARRAY_POINTER_EXT               =  0x808E;
const uint GL_NORMAL_ARRAY_POINTER_EXT               =  0x808F;
const uint GL_COLOR_ARRAY_POINTER_EXT                =  0x8090;
const uint GL_INDEX_ARRAY_POINTER_EXT                =  0x8091;
const uint GL_TEXTURE_COORD_ARRAY_POINTER_EXT        =  0x8092;
const uint GL_EDGE_FLAG_ARRAY_POINTER_EXT            =  0x8093;
const uint GL_DOUBLE_EXT                             =  GL_DOUBLE;
const uint GL_BGR_EXT                                =  0x80E0;
const uint GL_BGRA_EXT                               =  0x80E1;
const uint GL_COLOR_TABLE_FORMAT_EXT                 =  0x80D8;
const uint GL_COLOR_TABLE_WIDTH_EXT                  =  0x80D9;
const uint GL_COLOR_TABLE_RED_SIZE_EXT               =  0x80DA;
const uint GL_COLOR_TABLE_GREEN_SIZE_EXT             =  0x80DB;
const uint GL_COLOR_TABLE_BLUE_SIZE_EXT              =  0x80DC;
const uint GL_COLOR_TABLE_ALPHA_SIZE_EXT             =  0x80DD;
const uint GL_COLOR_TABLE_LUMINANCE_SIZE_EXT         =  0x80DE;
const uint GL_COLOR_TABLE_INTENSITY_SIZE_EXT         =  0x80DF;
const uint GL_COLOR_INDEX1_EXT                       =  0x80E2;
const uint GL_COLOR_INDEX2_EXT                       =  0x80E3;
const uint GL_COLOR_INDEX4_EXT                       =  0x80E4;
const uint GL_COLOR_INDEX8_EXT                       =  0x80E5;
const uint GL_COLOR_INDEX12_EXT                      =  0x80E6;
const uint GL_COLOR_INDEX16_EXT                      =  0x80E7;
const uint GL_MAX_ELEMENTS_VERTICES_WIN              =  0x80E8;
const uint GL_MAX_ELEMENTS_INDICES_WIN               =  0x80E9;
const uint GL_PHONG_WIN                              =  0x80EA;
const uint GL_PHONG_HINT_WIN                         =  0x80EB;
const uint GL_FOG_SPECULAR_TEXTURE_WIN               =  0x80EC;
const uint GL_LOGIC_OP                               =  GL_INDEX_LOGIC_OP;
const uint GL_TEXTURE_COMPONENTS                     =  GL_TEXTURE_INTERNAL_FORMAT;
const int GLU_VERSION_1_1                            =  1;
const int GLU_VERSION_1_2                            =  1;
const int GLU_INVALID_ENUM                           =  100900;
const int GLU_INVALID_VALUE                          =  100901;
const int GLU_OUT_OF_MEMORY                          =  100902;
const int GLU_INCOMPATIBLE_GL_VERSION                =  100903;
const int GLU_VERSION                                =  100800;
const int GLU_EXTENSIONS                             =  100801;
const int GLU_TRUE                                   =  GL_TRUE;
const int GLU_FALSE                                  =  GL_FALSE;
const int GLU_SMOOTH                                 =  100000;
const int GLU_FLAT                                   =  100001;
const int GLU_NONE                                   =  100002;
const int GLU_POINT                                  =  100010;
const int GLU_LINE                                   =  100011;
const int GLU_FILL                                   =  100012;
const int GLU_SILHOUETTE                             =  100013;
const int GLU_OUTSIDE                                =  100020;
const int GLU_INSIDE                                 =  100021;
const real GLU_TESS_MAX_COORD                        =  1.0e150;
const int GLU_TESS_WINDING_RULE                      =  100140;
const int GLU_TESS_BOUNDARY_ONLY                     =  100141;
const int GLU_TESS_TOLERANCE                         =  100142;
const int GLU_TESS_WINDING_ODD                       =  100130;
const int GLU_TESS_WINDING_NONZERO                   =  100131;
const int GLU_TESS_WINDING_POSITIVE                  =  100132;
const int GLU_TESS_WINDING_NEGATIVE                  =  100133;
const int GLU_TESS_WINDING_ABS_GEQ_TWO               =  100134;
const int GLU_TESS_BEGIN                             =  100100;
const int GLU_TESS_VERTEX                            =  100101;
const int GLU_TESS_END                               =  100102;
const int GLU_TESS_ERROR                             =  100103;
const int GLU_TESS_EDGE_FLAG                         =  100104;
const int GLU_TESS_COMBINE                           =  100105;
const int GLU_TESS_BEGIN_DATA                        =  100106;
const int GLU_TESS_VERTEX_DATA                       =  100107;
const int GLU_TESS_END_DATA                          =  100108;
const int GLU_TESS_ERROR_DATA                        =  100109;
const int GLU_TESS_EDGE_FLAG_DATA                    =  100110;
const int GLU_TESS_COMBINE_DATA                      =  100111;
const int GLU_TESS_ERROR1                            =  100151;
const int GLU_TESS_ERROR2                            =  100152;
const int GLU_TESS_ERROR3                            =  100153;
const int GLU_TESS_ERROR4                            =  100154;
const int GLU_TESS_ERROR5                            =  100155;
const int GLU_TESS_ERROR6                            =  100156;
const int GLU_TESS_ERROR7                            =  100157;
const int GLU_TESS_ERROR8                            =  100158;
const int GLU_TESS_MISSING_BEGIN_POLYGON             =  GLU_TESS_ERROR1;
const int GLU_TESS_MISSING_BEGIN_CONTOUR             =  GLU_TESS_ERROR2;
const int GLU_TESS_MISSING_END_POLYGON               =  GLU_TESS_ERROR3;
const int GLU_TESS_MISSING_END_CONTOUR               =  GLU_TESS_ERROR4;
const int GLU_TESS_COORD_TOO_LARGE                   =  GLU_TESS_ERROR5;
const int GLU_TESS_NEED_COMBINE_CALLBACK             =  GLU_TESS_ERROR6;
const int GLU_AUTO_LOAD_MATRIX                       =  100200;
const int GLU_CULLING                                =  100201;
const int GLU_SAMPLING_TOLERANCE                     =  100203;
const int GLU_DISPLAY_MODE                           =  100204;
const int GLU_PARAMETRIC_TOLERANCE                   =  100202;
const int GLU_SAMPLING_METHOD                        =  100205;
const int GLU_U_STEP                                 =  100206;
const int GLU_V_STEP                                 =  100207;
const int GLU_PATH_LENGTH                            =  100215;
const int GLU_PARAMETRIC_ERROR                       =  100216;
const int GLU_DOMAIN_DISTANCE                        =  100217;
const int GLU_MAP1_TRIM_2                            =  100210;
const int GLU_MAP1_TRIM_3                            =  100211;
const int GLU_OUTLINE_POLYGON                        =  100240;
const int GLU_OUTLINE_PATCH                          =  100241;
const int GLU_NURBS_ERROR1                           =  100251;
const int GLU_NURBS_ERROR2                           =  100252;
const int GLU_NURBS_ERROR3                           =  100253;
const int GLU_NURBS_ERROR4                           =  100254;
const int GLU_NURBS_ERROR5                           =  100255;
const int GLU_NURBS_ERROR6                           =  100256;
const int GLU_NURBS_ERROR7                           =  100257;
const int GLU_NURBS_ERROR8                           =  100258;
const int GLU_NURBS_ERROR9                           =  100259;
const int GLU_NURBS_ERROR10                          =  100260;
const int GLU_NURBS_ERROR11                          =  100261;
const int GLU_NURBS_ERROR12                          =  100262;
const int GLU_NURBS_ERROR13                          =  100263;
const int GLU_NURBS_ERROR14                          =  100264;
const int GLU_NURBS_ERROR15                          =  100265;
const int GLU_NURBS_ERROR16                          =  100266;
const int GLU_NURBS_ERROR17                          =  100267;
const int GLU_NURBS_ERROR18                          =  100268;
const int GLU_NURBS_ERROR19                          =  100269;
const int GLU_NURBS_ERROR20                          =  100270;
const int GLU_NURBS_ERROR21                          =  100271;
const int GLU_NURBS_ERROR22                          =  100272;
const int GLU_NURBS_ERROR23                          =  100273;
const int GLU_NURBS_ERROR24                          =  100274;
const int GLU_NURBS_ERROR25                          =  100275;
const int GLU_NURBS_ERROR26                          =  100276;
const int GLU_NURBS_ERROR27                          =  100277;
const int GLU_NURBS_ERROR28                          =  100278;
const int GLU_NURBS_ERROR29                          =  100279;
const int GLU_NURBS_ERROR30                          =  100280;
const int GLU_NURBS_ERROR31                          =  100281;
const int GLU_NURBS_ERROR32                          =  100282;
const int GLU_NURBS_ERROR33                          =  100283;
const int GLU_NURBS_ERROR34                          =  100284;
const int GLU_NURBS_ERROR35                          =  100285;
const int GLU_NURBS_ERROR36                          =  100286;
const int GLU_NURBS_ERROR37                          =  100287;
const int GLU_CW                                     =  100120;
const int GLU_CCW                                    =  100121;
const int GLU_INTERIOR                               =  100122;
const int GLU_EXTERIOR                               =  100123;
const int GLU_UNKNOWN                                =  100124;
const int GLU_BEGIN                                  =  GLU_TESS_BEGIN;
const int GLU_VERTEX                                 =  GLU_TESS_VERTEX;
const int GLU_END                                    =  GLU_TESS_END;
const int GLU_ERROR                                  =  GLU_TESS_ERROR;
const int GLU_EDGE_FLAG                              =  GLU_TESS_EDGE_FLAG;
const uint GLUT_RGB                                  = 0;
const uint GLUT_RGBA                                 = GLUT_RGB;
const uint GLUT_INDEX                                = 1;
const uint GLUT_SINGLE                               = 0;
const uint GLUT_DOUBLE                               = 2;
const uint GLUT_ACCUM                                = 4;
const uint GLUT_ALPHA                                = 8;
const uint GLUT_DEPTH                                = 16;
const uint GLUT_STENCIL                              = 32;
const uint GLUT_MULTISAMPLE                          = 128;
const uint GLUT_STEREO                               = 256;
const uint GLUT_LUMINANCE                            = 512;
const uint GLUT_LEFT_BUTTON                          = 0;
const uint GLUT_MIDDLE_BUTTON                        = 1;
const uint GLUT_RIGHT_BUTTON                         = 2;
const uint GLUT_DOWN                                 = 0;
const uint GLUT_UP                                   = 1;
const uint GLUT_KEY_F1                               = 1;
const uint GLUT_KEY_F2                               = 2;
const uint GLUT_KEY_F3                               = 3;
const uint GLUT_KEY_F4                               = 4;
const uint GLUT_KEY_F5                               = 5;
const uint GLUT_KEY_F6                               = 6;
const uint GLUT_KEY_F7                               = 7;
const uint GLUT_KEY_F8                               = 8;
const uint GLUT_KEY_F9                               = 9;
const uint GLUT_KEY_F10                              = 10;
const uint GLUT_KEY_F11                              = 11;
const uint GLUT_KEY_F12                              = 12;
const uint GLUT_KEY_LEFT                             = 100;
const uint GLUT_KEY_UP                               = 101;
const uint GLUT_KEY_RIGHT                            = 102;
const uint GLUT_KEY_DOWN                             = 103;
const uint GLUT_KEY_PAGE_UP                          = 104;
const uint GLUT_KEY_PAGE_DOWN                        = 105;
const uint GLUT_KEY_HOME                             = 106;
const uint GLUT_KEY_END                              = 107;
const uint GLUT_KEY_INSERT                           = 108;
const uint GLUT_LEFT                                 = 0;
const uint GLUT_ENTERED                              = 1;
const uint GLUT_MENU_NOT_IN_USE                      = 0;
const uint GLUT_MENU_IN_USE                          = 1;
const uint GLUT_NOT_VISIBLE                          = 0;
const uint GLUT_VISIBLE                              = 1;
const uint GLUT_HIDDEN                               = 0;
const uint GLUT_FULLY_RETAINED                       = 1;
const uint GLUT_PARTIALLY_RETAINED                   = 2;
const uint GLUT_FULLY_COVERED                        = 3;
const uint GLUT_RED                                  = 0;
const uint GLUT_GREEN                                = 1;
const uint GLUT_BLUE                                 = 2;
const uint GLUT_STROKE_ROMAN                         = 0;
const uint GLUT_STROKE_MONO_ROMAN                    = 1;
const uint GLUT_BITMAP_9_BY_15                       = 2;
const uint GLUT_BITMAP_8_BY_13                       = 3;
const uint GLUT_BITMAP_TIMES_ROMAN_10                = 4;
const uint GLUT_BITMAP_TIMES_ROMAN_24                = 5;
const uint GLUT_BITMAP_HELVETICA_10                  = 6;
const uint GLUT_BITMAP_HELVETICA_12                  = 7;
const uint GLUT_BITMAP_HELVETICA_18                  = 8;
const uint GLUT_WINDOW_X                             = cast(GLenum)( 100);
const uint GLUT_WINDOW_Y                             = cast(GLenum)( 101);
const uint GLUT_WINDOW_WIDTH                         = cast(GLenum)( 102);
const uint GLUT_WINDOW_HEIGHT                        = cast(GLenum)( 103);
const uint GLUT_WINDOW_BUFFER_SIZE                   = cast(GLenum)( 104);
const uint GLUT_WINDOW_STENCIL_SIZE                  = cast(GLenum)( 105);
const uint GLUT_WINDOW_DEPTH_SIZE                    = cast(GLenum)( 106);
const uint GLUT_WINDOW_RED_SIZE                      = cast(GLenum)( 107);
const uint GLUT_WINDOW_GREEN_SIZE                    = cast(GLenum)( 108);
const uint GLUT_WINDOW_BLUE_SIZE                     = cast(GLenum)( 109);
const uint GLUT_WINDOW_ALPHA_SIZE                    = cast(GLenum)( 110);
const uint GLUT_WINDOW_ACCUM_RED_SIZE                = cast(GLenum)( 111);
const uint GLUT_WINDOW_ACCUM_GREEN_SIZE              = cast(GLenum)( 112);
const uint GLUT_WINDOW_ACCUM_BLUE_SIZE               = cast(GLenum)( 113);
const uint GLUT_WINDOW_ACCUM_ALPHA_SIZE              = cast(GLenum)( 114);
const uint GLUT_WINDOW_DOUBLEBUFFER                  = cast(GLenum)( 115);
const uint GLUT_WINDOW_RGBA                          = cast(GLenum)( 116);
const uint GLUT_WINDOW_PARENT                        = cast(GLenum)( 117);
const uint GLUT_WINDOW_NUM_CHILDREN                  = cast(GLenum)( 118);
const uint GLUT_WINDOW_COLORMAP_SIZE                 = cast(GLenum)( 119);
const uint GLUT_WINDOW_NUM_SAMPLES                   = cast(GLenum)( 120);
const uint GLUT_WINDOW_STEREO                        = cast(GLenum)( 121);
const uint GLUT_WINDOW_CURSOR                        = cast(GLenum)( 122);
const uint GLUT_SCREEN_WIDTH                         = cast(GLenum)( 200);
const uint GLUT_SCREEN_HEIGHT                        = cast(GLenum)( 201);
const uint GLUT_SCREEN_WIDTH_MM                      = cast(GLenum)( 202);
const uint GLUT_SCREEN_HEIGHT_MM                     = cast(GLenum)( 203);
const uint GLUT_MENU_NUM_ITEMS                       = cast(GLenum)( 300);
const uint GLUT_DISPLAY_MODE_POSSIBLE                = cast(GLenum)( 400);
const uint GLUT_INIT_WINDOW_X                        = cast(GLenum)( 500);
const uint GLUT_INIT_WINDOW_Y                        = cast(GLenum)( 501);
const uint GLUT_INIT_WINDOW_WIDTH                    = cast(GLenum)( 502);
const uint GLUT_INIT_WINDOW_HEIGHT                   = cast(GLenum)( 503);
const uint GLUT_INIT_DISPLAY_MODE                    = cast(GLenum)( 504);
const uint GLUT_ELAPSED_TIME                         = cast(GLenum)( 700);
const uint GLUT_WINDOW_FORMAT_ID                     = cast(GLenum)( 123);
const uint GLUT_HAS_KEYBOARD                         = cast(GLenum)( 600);
const uint GLUT_HAS_MOUSE                            = cast(GLenum)( 601);
const uint GLUT_HAS_SPACEBALL                        = cast(GLenum)( 602);
const uint GLUT_HAS_DIAL_AND_BUTTON_BOX              = cast(GLenum)( 603);
const uint GLUT_HAS_TABLET                           = cast(GLenum)( 604);
const uint GLUT_NUM_MOUSE_BUTTONS                    = cast(GLenum)( 605);
const uint GLUT_NUM_SPACEBALL_BUTTONS                = cast(GLenum)( 606);
const uint GLUT_NUM_BUTTON_BOX_BUTTONS               = cast(GLenum)( 607);
const uint GLUT_NUM_DIALS                            = cast(GLenum)( 608);
const uint GLUT_NUM_TABLET_BUTTONS                   = cast(GLenum)( 609);
const uint GLUT_DEVICE_IGNORE_KEY_REPEAT             = cast(GLenum)( 610);
const uint GLUT_DEVICE_KEY_REPEAT                    = cast(GLenum)( 611);
const uint GLUT_HAS_JOYSTICK                         = cast(GLenum)( 612);
const uint GLUT_OWNS_JOYSTICK                        = cast(GLenum)( 613);
const uint GLUT_JOYSTICK_BUTTONS                     = cast(GLenum)( 614);
const uint GLUT_JOYSTICK_AXES                        = cast(GLenum)( 615);
const uint GLUT_JOYSTICK_POLL_RATE                   = cast(GLenum)( 616);
const uint GLUT_OVERLAY_POSSIBLE                     = cast(GLenum)( 800);
const uint GLUT_LAYER_IN_USE                         = cast(GLenum)( 801);
const uint GLUT_HAS_OVERLAY                          = cast(GLenum)( 802);
const uint GLUT_TRANSPARENT_INDEX                    = cast(GLenum)( 803);
const uint GLUT_NORMAL_DAMAGED                       = cast(GLenum)( 804);
const uint GLUT_OVERLAY_DAMAGED                      = cast(GLenum)( 805);
const uint GLUT_VIDEO_RESIZE_POSSIBLE                = cast(GLenum)( 900);
const uint GLUT_VIDEO_RESIZE_IN_USE                  = cast(GLenum)( 901);
const uint GLUT_VIDEO_RESIZE_X_DELTA                 = cast(GLenum)( 902);
const uint GLUT_VIDEO_RESIZE_Y_DELTA                 = cast(GLenum)( 903);
const uint GLUT_VIDEO_RESIZE_WIDTH_DELTA             = cast(GLenum)( 904);
const uint GLUT_VIDEO_RESIZE_HEIGHT_DELTA            = cast(GLenum)( 905);
const uint GLUT_VIDEO_RESIZE_X                       = cast(GLenum)( 906);
const uint GLUT_VIDEO_RESIZE_Y                       = cast(GLenum)( 907);
const uint GLUT_VIDEO_RESIZE_WIDTH                   = cast(GLenum)( 908);
const uint GLUT_VIDEO_RESIZE_HEIGHT                  = cast(GLenum)( 909);
const uint GLUT_NORMAL                               = cast(GLenum)( 0);
const uint GLUT_OVERLAY                              = cast(GLenum)( 1);
const uint GLUT_ACTIVE_SHIFT                         = 1;
const uint GLUT_ACTIVE_CTRL                          = 2;
const uint GLUT_ACTIVE_ALT                           = 4;
const uint GLUT_CURSOR_RIGHT_ARROW                   = 0;
const uint GLUT_CURSOR_LEFT_ARROW                    = 1;
const uint GLUT_CURSOR_INFO                          = 2;
const uint GLUT_CURSOR_DESTROY                       = 3;
const uint GLUT_CURSOR_HELP                          = 4;
const uint GLUT_CURSOR_CYCLE                         = 5;
const uint GLUT_CURSOR_SPRAY                         = 6;
const uint GLUT_CURSOR_WAIT                          = 7;
const uint GLUT_CURSOR_TEXT                          = 8;
const uint GLUT_CURSOR_CROSSHAIR                     = 9;
const uint GLUT_CURSOR_UP_DOWN                       = 10;
const uint GLUT_CURSOR_LEFT_RIGHT                    = 11;
const uint GLUT_CURSOR_TOP_SIDE                      = 12;
const uint GLUT_CURSOR_BOTTOM_SIDE                   = 13;
const uint GLUT_CURSOR_LEFT_SIDE                     = 14;
const uint GLUT_CURSOR_RIGHT_SIDE                    = 15;
const uint GLUT_CURSOR_TOP_LEFT_CORNER               = 16;
const uint GLUT_CURSOR_TOP_RIGHT_CORNER              = 17;
const uint GLUT_CURSOR_BOTTOM_RIGHT_CORNER           = 18;
const uint GLUT_CURSOR_BOTTOM_LEFT_CORNER            = 19;
const uint GLUT_CURSOR_INHERIT                       = 100;
const uint GLUT_CURSOR_NONE                          = 101;
const uint GLUT_CURSOR_FULL_CROSSHAIR                = 102;
const uint GLUT_KEY_REPEAT_OFF                       = 0;
const uint GLUT_KEY_REPEAT_ON                        = 1;
const uint GLUT_KEY_REPEAT_DEFAULT                   = 2;
const uint GLUT_JOYSTICK_BUTTON_A                    = 1;
const uint GLUT_JOYSTICK_BUTTON_B                    = 2;
const uint GLUT_JOYSTICK_BUTTON_C                    = 4;
const uint GLUT_JOYSTICK_BUTTON_D                    = 8;
const int GLUT_GAME_MODE_ACTIVE                      = cast(GLenum)( 0);
const int GLUT_GAME_MODE_POSSIBLE                    = cast(GLenum)( 1);
const int GLUT_GAME_MODE_WIDTH                       = cast(GLenum)( 2);
const int GLUT_GAME_MODE_HEIGHT                      = cast(GLenum)( 3);
const int GLUT_GAME_MODE_PIXEL_DEPTH                 = cast(GLenum)( 4);
const int GLUT_GAME_MODE_REFRESH_RATE                = cast(GLenum)( 5);
const int GLUT_GAME_MODE_DISPLAY_CHANGED             = cast(GLenum)( 6);
