import std.c.stdlib;
import std.c.stdio;
import gllap ;

double ox=0.0 , oy=0.0 , oz=0.0  ;

extern (C) void idle()
{
  D_glutPostRedisplay();
}

extern (C) void display()
{

  D_glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  D_glLoadIdentity();
  D_gluLookAt(0.0, 0.0, 5.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
  
  D_glRotated( ox, 1.0, 0.0, 0.0 );
  D_glRotated( oy, 0.0, 1.0, 0.0 );
  D_glRotated( oz, 0.0, 0.0, 1.0 );

  ox=ox+1.2 ;
  if( ox>360 ) ox=ox-360.0 ;
  oy=oy+1.5 ;
  if( oy>360 ) oy=oy-360.0 ;
  oz=oz+1.8 ;
  if( oz>360 ) oz=oz-360.0 ;
  D_glutSolidTorus( 0.1, 0.4, 16, 16);

  D_glFlush();
  D_glutSwapBuffers();
}


extern (C) void keyboard(ubyte key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
    exit(0);
  default:
    break;
  }
}

extern (C) void resize(int w, int h)
{
  D_glViewport(0, 0, w, h);
  D_glMatrixMode(GL_PROJECTION);
  D_glLoadIdentity();
  D_gluPerspective(30.0, cast(double)(w) / cast(double)(h), 1.0, 100.0);
  D_glMatrixMode(GL_MODELVIEW);
  D_glLoadIdentity();
}


int main(char[][] args)
{
  int argc = args.length;
  char** argv = new char*[argc];
  
  for(int i=0; i<argc; i++){
    argv[i] = args[i];
  }
  
  D_glutInit(&argc, argv);
  
  D_glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE );
  D_glutCreateWindow("Opengl with D");
  D_glutDisplayFunc(&display);
  D_glutReshapeFunc(&resize);
  D_glutKeyboardFunc(&keyboard);
  D_glutIdleFunc(&idle);

  D_glClearColor(0.0,0.0,1.0,0.5) ;
  D_glEnable(GL_DEPTH_TEST);
  D_glEnable(GL_LIGHTING);
  D_glEnable(GL_LIGHT0);
  
  D_glutMainLoop();
  return 0;
}
